#imports
import numpy as np
import pandas as pd
from sklearn.cluster import DBSCAN


#This function uses DBSCAN to find the the water in frame n and frame n+1, then
# write the molecules that only apperar in frame n (and not in frame n+1) to
# a csv file
def dbscanClustering(frame1, frame2, writefile):
    with open(frame1,'r') as f:
        lines = f.readlines()
        lines = lines[9:]

    molecules = []
    for line in lines:
        values = line.split()
        values.pop(1)
        values.pop(-1)
        values.pop(-1)
        values.pop(-1)
        molecules.append(values)
    df = pd.DataFrame(molecules,columns=['id','x', 'y', 'z'])
    ogdf = df
    df2 = df.drop('id', axis=1)

    # Convert DataFrame to numpy array
    X = df2.values.astype(np.float)


    # create a DBSCAN object with the desired parameters
    eps = 4
    min_samples = 8
    dbscan = DBSCAN(eps=eps, min_samples=min_samples)

    # fit and predict the clusters
    dbscan.fit(X)
    clusters = dbscan.labels_

    # count the number of points in each cluster
    unique_clusters, counts = np.unique(clusters, return_counts=True)
    num_clusters = len(unique_clusters)
    

    # find the cluster with the largest number of points
    largest_cluster_idx = np.argmax(counts)
    largest_cluster_label = unique_clusters[largest_cluster_idx]
    largest_cluster_points = X[clusters == largest_cluster_label, :]

    df3 = pd.DataFrame(largest_cluster_points,columns=['x', 'y', 'z'])
    df['id'] = df['id'].astype(int)
    df['x'] = df['x'].astype(float)
    df['y'] = df['y'].astype(float)
    df['z'] = df['z'].astype(float)
    merged = pd.merge(df, df3, on=['x', 'y', 'z'])


    with open(frame2,'r') as f:
        lines = f.readlines()
        lines = lines[9:]

    molecules = []
    for line in lines:
        values = line.split()
        values.pop(1)
        values.pop(-1)
        values.pop(-1)
        values.pop(-1)
        molecules.append(values)
    df = pd.DataFrame(molecules,columns=['id','x', 'y', 'z'])
    df2 = df.drop('id', axis=1)

    # Convert DataFrame to numpy array
    X = df2.values.astype(np.float)


    # create a DBSCAN object with the desired parameters
    eps = 4
    min_samples = 8
    dbscan = DBSCAN(eps=eps, min_samples=min_samples)

    # fit and predict the clusters
    dbscan.fit(X)
    clusters = dbscan.labels_

    # count the number of points in each cluster
    unique_clusters, counts = np.unique(clusters, return_counts=True)
    num_clusters = len(unique_clusters)


    # find the cluster with the largest number of points
    largest_cluster_idx = np.argmax(counts)
    largest_cluster_label = unique_clusters[largest_cluster_idx]
    largest_cluster_points = X[clusters == largest_cluster_label, :]

    df3 = pd.DataFrame(largest_cluster_points,columns=['x', 'y', 'z'])
    df['id'] = df['id'].astype(int)
    df['x'] = df['x'].astype(float)
    df['y'] = df['y'].astype(float)
    df['z'] = df['z'].astype(float)
    merged2 = pd.merge(df, df3, on=['x', 'y', 'z'])



    ids_df1 = set(merged['id'])
    ids_df2 = set(merged2['id'])
    intermediates = list(ids_df2.difference(ids_df1))


    matching_rows = ogdf[ogdf['id'].isin(intermediates)]

    filtered_rows = matching_rows[(matching_rows['x'] >= (307)) & (matching_rows['x'] <= 430)]


    filtered_rows.to_csv(writefile, index=False)

def run(path):
    for i in range (1,101):
        frame1 = path + 'frame_' + str(i) + '.txt'
        frame2 = path + 'frame_' + str(i+1) + '.txt'
        writefile = path + 'intermediates_' + str(i) + '_' + str(i+1) +  '.csv'
        dbscanClustering(frame1, frame2, writefile)
        print(i)

path = 'finalThree/growth/'

run(path)

