#imports
import numpy as np
import pandas as pd
from sklearn.cluster import DBSCAN


def water(frame, writefile):
    # Read the file to be analysed
    with open(frame,'r') as f:
        lines = f.readlines()
        lines = lines[9:]

    molecules = []
    for line in lines:
        values = line.split()
        values.pop(1)
        values.pop(-1)
        values.pop(-1)
        values.pop(-1)
        molecules.append(values)
    # Store the values fram the txt file in a dataframe called df
    df = pd.DataFrame(molecules,columns=['id','x', 'y', 'z'])
    # copy df, but neglect the id's
    df2 = df.drop('id', axis=1)

    # Convert DataFrame to numpy array
    X = df2.values.astype(np.float)


    # create a DBSCAN object with the desired parameters
    eps = 4 
    min_samples = 8 
    dbscan = DBSCAN(eps=eps, min_samples=min_samples)

    # fit and predict the clusters
    dbscan.fit(X)
    clusters = dbscan.labels_

    # count the number of points in each cluster
    unique_clusters, counts = np.unique(clusters, return_counts=True)

    # find the cluster with the largest number of points
    largest_cluster_idx = np.where((unique_clusters != -1) & (counts == max(counts[unique_clusters != -1])))[0][0]
    largest_cluster_label = unique_clusters[largest_cluster_idx]
    largest_cluster_points = X[clusters == largest_cluster_label, :]

    # Create dataframes
    df3 = pd.DataFrame(largest_cluster_points,columns=['x', 'y', 'z'])
    df['id'] = df['id'].astype(int)
    df['x'] = df['x'].astype(float)
    df['y'] = df['y'].astype(float)
    df['z'] = df['z'].astype(float)

    # merge dataframe df and df3
    merged = pd.merge(df, df3, on=['x', 'y', 'z'])
    
    # Write the dataframe to a csv file
    merged.to_csv(writefile, index=False)

#The run function, this function loops through every fram en applies the water function on them
def run(path):
    for i in range(1, 102):
        frame = path + '/frame_' + str(i) + '.txt'
        writefile = path + '2/water_' + str(i) + '.csv'
        water(frame, writefile)

#The path to the folder where everything can be found.
path = 'finalThree/growth'

#The run function initiate the entire script
run(path)