#imports
import numpy as np

#This writes a trajectory file that simulate the "life" of a intermediate structure
#The variable cluster is the intermediate structure that will be simulated
#The variable writefile is a string that contains the information on where the 
# trajectory file will be saved and the name of the new trajectory file
def simulate(cluster, writefile):
    atoms=cluster[1]
    with open(writefile,'w') as f:
        for i in range(1,102):
            atoms_frame_info=[]
            lines_to_write=[]
            readfile='finalThree/growth/frame_'+str(i)+'.txt'
            with open(readfile,'r') as f2:
                lines=f2.readlines()
                first=lines[:3]
                second=lines[4:9]
                data=lines[9:]
                for atom in atoms:
                    for line in data:
                        info=line.split()
                        if int(atom)==int(info[0]):
                            atoms_frame_info.append([int(info[0]),
                            float(info[2]),float(info[3]),float(info[4])])
                for atom2 in atoms_frame_info:
                    x=atom2[1]
                    y=atom2[2]
                    z=atom2[3]
                    for line2 in data:
                        info=line2.split()
                        x2=float(info[2])
                        y2=float(info[3])
                        z2=float(info[4])
                        distance=np.sqrt((x2-x)**2+(y2-y)**2+(z2-z)**2)
                        if distance<=3.5:
                            lines_to_write.append(line2)
            for l in first:
                f.write(l)
            f.write(str(len(lines_to_write))+'\n')
            for l in second:
                f.write(l)
            for l in lines_to_write:
                f.write(l)
            print(i)

simulate([4, [20290, 14882, 13457, 15448], 1.939, 3.68, 37], 'finalThree/method3.2/testCycleIce4.txt')