#imports
import numpy as np
import pandas as pd
from sklearn.cluster import DBSCAN

def potenialIntermediates(readfile,writefile,writefile2,largestcluster):
    df = pd.read_csv(readfile)
    df2 = df.drop('id', axis=1)

    # Convert DataFrame to numpy array
    X = df2.values.astype(np.float)

    # create a DBSCAN object with the desired parameters
    eps = 4 # maximum interaction distance between two water molecules
    min_samples = 2  #can be just a singel water molecule with no bonds
    dbscan = DBSCAN(eps=eps, min_samples=min_samples, n_jobs=1)

    # fit and predict the clusters
    dbscan.fit(X)
    clusters = dbscan.labels_

    # count the number of points in each cluster
    unique_clusters, counts = np.unique(clusters, return_counts=True)
    num_clusters = len(unique_clusters)

    # create a boolean mask to only keep clusters between 3 and 5 points.
    mask = (counts > 2) 

    # get the indices of the points in clusters with more than one and less than six points
    indices = np.where(mask)[0]
    point_indices = [np.where(clusters == i)[0] for i in unique_clusters[indices]]
    
    with open(writefile2,'w') as f:
        for cluster in point_indices:
            neighbours=[]
            for i in cluster:
                neighbours.append(list(df.iloc[i]))
            clustersize=len(neighbours)
            if clustersize>largestcluster:
                largestcluster=clustersize
            f.write(str(neighbours)+'\n')


    # create a new DataFrame with the selected points
    new_df = df.iloc[np.concatenate(point_indices)]


    new_df.to_csv(writefile, index=False)

    return largestcluster

def run(path):
    largestcluster=0
    for i in range(1,101):
        readfile = path + 'intermediates_' + str(i) + '_' + str(i+1) + '.csv'
        writefile = path + 'analyzed_intermediates_'+ str(i) + '_' + str(i+1) + '.csv'
        writefile2 = 'finalThree/method1/''analyzed_intermediates_'+ str(i) + '_' + str(i+1) + '.txt'
        largestcluster=potenialIntermediates(readfile, writefile, writefile2,largestcluster)
    print('largestcluster is: '+str(largestcluster))

path = 'finalThree/growth/'
run(path)