#imports
import numpy as np
import os

#This function calculates the average distance from a neighbour to the center atom for
# an intermediate structure. It also calculates the sum of all neighbours to center distances
# in an intermediates structure.
#The variabel readfile contains the file to be analyzed, writefile is the file where intermeriates
# of each size found is written, and writefile2 contains all intermediate structures. The variable
# frame is the frame that is analyzed.
points=[]
numbers=[]
def average_distance(readfile, writefile,writefile2,frame):
    with open(readfile,'r') as f, open(writefile2,'a') as f3:
        for line in f:
            neighbours=np.array(eval(line),float)
            neighbours=neighbours.tolist()
            n = len(neighbours)
            total_distance = 0
            total_pairs = n * (n - 1) / 2
            atoms=[]
            for atom in neighbours:
                atoms.append(int(atom[0]))
            for i in range(n - 1):
                for j in range(i + 1, n):
                    id1, x1, y1 , z1 = neighbours[i]
                    id2, x2, y2, z2 = neighbours[j]
                    euclidean_distance = np.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2+(z2 - z1)**2)
                    total_distance += euclidean_distance
            average_distance = round(total_distance/total_pairs,4)
            info=[n,atoms,average_distance,round(total_distance,4),frame]
            info2=[n,atoms,frame]
            writefile = 'finalThree/method1/intermediates_method1_n_1_c_'+str(n)+'.txt'
            f2 = open(writefile,'a')
            f2.write(str(info)+'\n')
            f2.close
            f3.write(str(info2)+'\n')

            if n==4:
                point=[average_distance,round(total_distance,4)]
                numbers.append(average_distance)
                points.append(point)
            

#average_distance('finalThree/method1/analyzed_intermediates_1_2.txt', '')

#This function initiates the script. The variable largest cluster is the number of molecules in the
#largest cluster that was found in the previouse step.
def run(largestcluster):
    for i in range(3,largestcluster+1):
        writefile = 'finalThree/method1/intermediates_method1_n_1_c_'+str(i)+'.txt'
        f = open(writefile,'w')
        f.close
    writefile2='finalThree/method1/intermediates_method1_n_1_allclusters.txt'
    f = open(writefile2,'w')
    f.close
    for i in range(1,101):
        readfile = 'finalThree/method1/analyzed_intermediates_'+str(i)+'_'+str(i+1)+'.txt'
        average_distance(readfile,writefile,writefile2,i)
    for i in range(3,largestcluster+1):
        if os.stat('finalThree/method1/intermediates_method1_n_1_c_'+str(i)+'.txt').st_size == 0:
            os.remove('finalThree/method1/intermediates_method1_n_1_c_'+str(i)+'.txt')

run(75)

