#imports
import numpy as np
import pandas as pd

#This function calculates the average distance from a neighbour to the center atom for
# an intermediate structure. It also calculates the displacement from frame n to frame n+1 
# in an intermediates structure.
#The variabel theta is largest angular displacemen that is allowed, and r is the maximum
# distance allowed between a neighbour and the center molecule.
def displacement(theta,r):
    writefile = 'finalThree/method2/distances.txt'
    writefile2 = 'finalThree/method2/avg_dist.txt'
    writefile3 = 'finalThree/method2/avg_dist_c3.txt'
    writefile4 = 'finalThree/method2/avg_dist_c4.txt'
    writefile5 = 'finalThree/method2/avg_dist_c5.txt'
    f3 = open(writefile, 'w')
    f4 = open(writefile2, 'w')
    f5 = open(writefile3, 'w')
    f6 = open(writefile4, 'w')
    f7 = open(writefile5, 'w')
   
    for i in range(1,101):
        readfile1 = 'finalThree/growth2/rotated_'+str(i)+'_'+str(i+1)+'.txt'
        readfile2 = 'finalThree/growth2/water_neighbours_'+str(i+1)+'_new_coordinates.txt'
        f = open(readfile1, 'r')
        for line in f:
            neighbours=np.array(eval(line),float)
            neighbours=neighbours.tolist()
            if neighbours[0][4]<=theta:
                f2 = open(readfile2, 'r')
                for line2 in f2:
                    neighbours2=np.array(eval(line2),float)
                    neighbours2=neighbours2.tolist()
                    if neighbours[0][0]== neighbours2[0][0]:
                        columnNames=['id','x','y','z', 'angle']
                        columnNames2=['id','x','y','z']
                        df = pd.DataFrame(neighbours,columns=columnNames)
                        df2 = pd.DataFrame(neighbours2,columns=columnNames2)
                        merged_df = pd.merge(df2, df, on='id', how='inner')
                        distances=[]
                        total_d=0
                        total_center_distance=0
                        ids=[]
                        data=[]
                        for index,row in merged_df.iterrows():
                            x1 = row[1]
                            y1 = row[2]
                            z1 = row[3]
                            x2 = row[4]
                            y2 = row[5]
                            z2 = row[6]
                            d = round(np.sqrt((x2 - x1)**2 + (y2 - y1)**2 + (z2 - z1)**2),4) #displacement from previouse frame
                            distance_to_center = round(np.sqrt((x1 - 0)**2 + (y1 - 0)**2 + (z1 - 0)**2),4)
                            atom =[int(row[0]),x2,y2,z2,d, distance_to_center]
                            distances.append(atom)
                            if distance_to_center<=r:
                                ids.append(int(row[0]))
                                total_center_distance+=distance_to_center
                                total_d+=d
                        if len(ids)>0:
                            average_center_distance=round(total_center_distance/len(ids),4)
                            info=[len(ids),ids,average_center_distance,round(total_d,4)]
                            f4.write(str(info)+'\n')
                            if len(ids)==3:
                                f5.write(str(info)+'\n')
                            if len(ids)==4:
                                f6.write(str(info)+'\n')
                            if len(ids)==5:
                                f7.write(str(info)+'\n')



                        f3.write(str(distances)+'\n')
                        f2.close()
                        break
        print(i)
    f.close()
    f3.close()
    f4.close()
    f5.close()
    f6.close()
    f7.close()


displacement(10,4)



    