#imports
import numpy as np
import pandas as pd
import math


#This function takes the coordinates of two molecules and calculates the
# rotatin angel between them
def calculate_rotation_angle_direction(x1, y1, z1, x2, y2, z2):
    # Vector A at t=0
    A0 = np.array([x1, y1, z1])
    # Vector A at t=1
    A1 = np.array([x2, y2, z2])

    # Normalize vectors
    A0_normalized = A0 / np.linalg.norm(A0)
    A1_normalized = A1 / np.linalg.norm(A1)

    # Compute cross product and rotation angle
    cross_product = np.cross(A0_normalized, A1_normalized)
    angle = math.acos(np.dot(A0_normalized, A1_normalized))

    # Determine rotation direction
    rotation_direction = 1 if np.dot(cross_product, A1_normalized) > 0 else -1

    return angle, rotation_direction

# This function performs the rotational shift in a neighbourhood.
def analyzer(readfile, readfile2, writefile):
    f = open(readfile, 'r')
    f3 = open(writefile, 'w')
    holder = []

    for line in f:
        neighbours=np.array(eval(line),float)
        neighbours=neighbours.tolist()
        f2 = open(readfile2, 'r')

        for line2 in f2:
            neighbours2=np.array(eval(line2),float)
            neighbours2=neighbours2.tolist()
            #Find the matching center atoms in both frames
            if neighbours[0][0]== neighbours2[0][0]:
                center1=neighbours.pop(0)
                center2=neighbours2.pop(0)
                columnNames=['id','x','y','z']
                df = pd.DataFrame(neighbours,columns=columnNames)
                df2 = pd.DataFrame(neighbours2,columns=columnNames)
                merged_df = pd.merge(df, df2, on='id', how='inner')
                x1 = merged_df.iloc[1]['x_x']
                y1 = merged_df.iloc[1]['y_x']
                z1 = merged_df.iloc[1]['z_x']
                x2 = merged_df.iloc[1]['x_y']
                y2 = merged_df.iloc[1]['y_y']
                z2 = merged_df.iloc[1]['z_y']
                theta, rotation_direction = calculate_rotation_angle_direction(x1, y1, z1, x2, y2, z2)
                rotation_direction = rotation_direction*(-1) #we want to rotate the atoms back
                angle = round(np.degrees(theta),2)
                df3 = merged_df.drop(0)
                df4 = pd.DataFrame(columns=['id', 'x', 'y','z','angle'])
                center2.append(angle)
                df4.loc[len(df4)] = center2
                rotated = [[int(center2[0]),center2[1],center2[2],center2[3],center2[4]]]

                def rotate(row):
                    # Define the 3D vector
                    vector = np.array([row[4],row[5],row[6]])
                    

                    # Define the rotation matrix
                    rot_z = np.array([
                        [np.cos(theta), -rotation_direction*np.sin(theta), 0],
                        [rotation_direction*np.sin(theta), np.cos(theta), 0],
                        [0, 0, 1]
                    ])  # 3x3 rotation matrix around z-axis
                 
                    # Perform the rotation
                    vector_rotated = np.dot(rot_z, vector)
                    displacement =np.sqrt((row[4]-vector_rotated[0])**2+(row[5]-vector_rotated[1])**2+(row[6]-vector_rotated[2])**2)
                    vr = [row[0],vector_rotated[0],vector_rotated[1],vector_rotated[2],angle]
                    df4.loc[len(df4)] = vr
                    rotated.append(vr)
                    
                
                df3.apply(rotate, axis=1) 
                f3.write(str(rotated)+'\n')
                f2.close()
                break
            #holder.append(rotated) 

    f.close()
    f3.close()


#Initiates the entire script
def run (path):
    for i in range (72,101):
        readfile = path + '/water_neighbours_' + str(i) + '_new_coordinates.txt'
        readfile2 = path + '/water_neighbours_' + str(i+1) + '_new_coordinates.txt'
        writefile = path+'/rotated_'+str(i)+'_'+str(i+1)+'.txt'
        analyzer(readfile, readfile2, writefile)
        print(i)   

path1 = "finalThree/growth2"

run(path1)
