#imports
import pandas as pd
import numpy as np

#This function takes in a frame containg all molecules in the liquid state, then finds 
# the neighbours of each molecule within a distance 4, and writes the results to a 
# textfile writefile.

def neighbours(readfile, writefile):
    df = pd.read_csv(readfile)
    df2 = pd.read_csv(readfile)
    container =[]


    def neighbourhood(row):
        neighbours=[]
        x=float(row[1])
        y=float(row[2])
        z=float(row[3])
        point =np.array((x,y,z))
        molecule = [int(row[0]),x,y,z]
        neighbours.append(molecule)
        for atom in df2.itertuples(index=False):
            x=float(atom[1])
            y=float(atom[2])
            z=float(atom[3]) 
            point2 =np.array((x,y,z))
            distance = np.linalg.norm(point-point2)
            if (distance !=0 and distance <=4):
                molecule=[int(atom[0]),x,y,z]
                neighbours.append(molecule)
        container.append(neighbours)

    df.apply(neighbourhood, axis=1)
    
    with open(writefile,'w') as f:
        for element in container:
            f.write(str(element)+'\n')

#Initiates the entire script, path is the where the files that will be analyzed can be found.
def run(path):
    for i in range(1, 102):
        readfile = path + '/water_' + str(i) + '.csv'
        writefile = 'finalThree/method3.2/water_neighbours_' + str(i) + '.txt'
        neighbours(readfile, writefile)
        print(i)

path = 'finalThree/growth2'

run(path)