#imports
import numpy as np
import pandas as pd

#This function takes in an vector and returns the unit vector
def unit_vector(vector):
    """ Returns the unit vector of the vector."""
    return vector / np.linalg.norm(vector)

#This function calculates the angular displacement in a neighbourhood from frame n
# and frame n+1.
#The variabel readfile contains frame n, while readfile2 contains frame n+1
#the variable writefile is the name of the file where the angular displacement between
# two frames is saved.
#The variable theta is the the maximum angle that is allowed as an angular dispalcement
# for a molecule. 
def analyzer(readfile, readfile2, writefile,theta):
    with open(readfile, 'r') as f, open(writefile, 'w') as f3:
        for line in f:
            neighbours=np.array(eval(line),float)
            neighbours=neighbours.tolist()
            f2 = open(readfile2, 'r')
            center1=neighbours.pop(0)
            for line2 in f2:
                neighbours2=np.array(eval(line2),float)
                neighbours2=neighbours2.tolist()
                center2=neighbours2.pop(0)
                if center1[0]== center2[0]:
                    columnNames=['id','x','y','z']
                    df = pd.DataFrame(neighbours,columns=columnNames)
                    df2 = pd.DataFrame(neighbours2,columns=columnNames)
                    merged_df = pd.merge(df, df2, on='id', how='inner')
                    #df3 = pd.DataFrame(columns=['id', 'x1', 'y1','z1','x2','y2','z2','d1','d2','angle'])
                    for i in range(6):
                        center2.append(0)
                    #df3.loc[len(df3)] = center2
                    data=[center2]
                    for index, row in merged_df.iterrows():
                        info=list(row)
                        x1 = row[1]
                        y1 = row[2]
                        z1 = row[3]
                        vector1 = [x1,y1,z1]
                        x2 = row[4]
                        y2 = row[5]
                        z2 = row[6]
                        vector2 = [x2,y2,z2]
                        unitvec1 = unit_vector(vector1)
                        unitvec2 = unit_vector(vector2)
                        angle_rad = np.arccos(np.clip(np.dot(unitvec1, unitvec2), -1.0, 1.0))
                        angle = round(np.degrees(angle_rad),2)
                        if angle<=theta:
                            euclidean_distance_1=np.sqrt(x1**2+y1**2+z1**2)
                            info.append(euclidean_distance_1)
                            euclidean_distance_2=np.sqrt(x2**2+y2**2+z2**2)
                            info.append(euclidean_distance_2)
                            info.append(angle)
                            data.append(info)
                    if len(data)>1:
                        f3.write(str(data)+'\n')
                        #df3.loc[len(df3)] = info

#The run function initiates the entire script
#The variable path is a string that conatins the path to the folder where the files that
# will be analyzed is contained, and where the analyzed files will be saved.
#The variable theta is the the maximum angle that is allowed as an angular dispalcement
# for a molecule.
def run (path, theta):
    for i in range (2,102):
        readfile = path + '/water_neighbours_' + str(i) + '_new_coordinates.txt'
        readfile2 = path + '/water_neighbours_' + str(i+1) + '_new_coordinates.txt'
        writefile = path+'/angle'+str(i)+'_'+str(i+1)+'.txt'
        analyzer(readfile, readfile2, writefile, theta)
        print(i)
        

path1 = "finalThree/method3.2"

run(path1, 10)
